diff --git a/src/Fl_x.cxx b/src/Fl_x.cxx
index 772acae..04f2162 100644
--- a/src/Fl_x.cxx
+++ b/src/Fl_x.cxx
@@ -2883,6 +2883,34 @@ void Fl_Window::label(const char *name,const char *iname) {
   }
 }
 
+static int wmClientMsg(Display *disp, Window win, const char *msg,
+  unsigned long data0=0, unsigned long data1=0, 
+  unsigned long data2=0, unsigned long data3=0,
+  unsigned long data4=0) 
+{
+    XEvent event;
+    long mask = SubstructureRedirectMask | SubstructureNotifyMask;
+
+    event.xclient.type = ClientMessage;
+    event.xclient.serial = 0;
+    event.xclient.send_event = True;
+    event.xclient.message_type = XInternAtom(disp, msg, False);
+    event.xclient.window = win;
+    event.xclient.format = 32;
+    event.xclient.data.l[0] = data0;
+    event.xclient.data.l[1] = data1;
+    event.xclient.data.l[2] = data2;
+    event.xclient.data.l[3] = data3;
+    event.xclient.data.l[4] = data4;
+
+    if (XSendEvent(disp, DefaultRootWindow(disp), False, mask, &event)) {
+      return EXIT_SUCCESS;
+    } else {
+      fprintf(stderr, "Cannot send %s event.\n", msg);
+      return EXIT_FAILURE;
+    }
+}
+
 ////////////////////////////////////////////////////////////////
 // Implement the virtual functions for the base Fl_Window class:
 
@@ -2915,6 +2943,7 @@ void Fl_Window::show() {
     }
     Fl_X::make_xid(this);
   } else {
+    wmClientMsg(fl_display, i->xid, "_NET_ACTIVE_WINDOW");
     XMapRaised(fl_display, i->xid);
   }
 #ifdef USE_PRINT_BUTTON
